import java.util.Timer;
import java.util.TimerTask;
import javax.microedition.lcdui.*;
import javax.microedition.midlet.MIDlet;

/**
 * @author http://truecoder.ru
 */
public class TimerTest extends MIDlet implements CommandListener {

    private Display display = Display.getDisplay(this);
    public Command cExit = new Command("Выход", Command.EXIT, 0);
    private Command cShedule = new Command("Запуск", Command.OK, 0);
    private Command cStop = new Command("Стоп", Command.STOP, 0);
    private List mainMenu;
    private TimerTask tTask;
    private Timer timer = new Timer();

    public void startApp() {
        display.setCurrent(getMainMenu());
    }

    public void pauseApp() {
    }

    public void destroyApp(boolean unconditional) {
        display.setCurrent(null);
        notifyDestroyed();
    }

    private void initTask() {
        tTask = new TimerTask() {

            public void run() {
                display.vibrate(100);
            }
        };
    }

    private Displayable getMainMenu() {
        if (mainMenu == null) {
            mainMenu = new List("Меню", List.IMPLICIT);
            mainMenu.addCommand(cExit);
            mainMenu.addCommand(cShedule);
            mainMenu.setCommandListener(this);
            mainMenu.append("Задержка 1000", null);
            mainMenu.append("Задержка 1000. Интервал 3000", null);
        }
        return mainMenu;
    }

    private void sheduleTimer(int timerIndex) {
        initTask();
        if (timerIndex == 0) {
            // запускаем таймер с задержкой 1000 миллисекунд
            timer.schedule(tTask, 1000);
        } else {
            // запускаем таймер с задержкой 1000 миллисекунд, а
            // задание будет выполняться через каждые 3 секунды
            timer.schedule(tTask, 1000, 3000);
        }
        mainMenu.removeCommand(cShedule);
        mainMenu.addCommand(cStop);
    }

    private void stopTimer() {
        if (timer != null) {
            tTask.cancel();
        }
        mainMenu.removeCommand(cStop);
        mainMenu.addCommand(cShedule);
    }

    public void commandAction(Command cmd, Displayable disp) {
        if (cmd == cExit) {
            destroyApp(true);
            return;
        }
        if (disp == getMainMenu()) {
            if (cmd == cShedule) {
                sheduleTimer(mainMenu.getSelectedIndex());
            } else if (cmd == cStop) {
                stopTimer();
            }
        }
    }
}